#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "dll.ch"

#define WS_CHILD     0x40000000
#define WS_VISIBLE   0x10000000
//'
//' Windows User Interface Services
//' http://msdn.microsoft.com/en-us/library/ms961540.aspx
#define SWP_NOMOVE            0x2
#define SWP_NOZORDER          0x4
#define HWND_BOTTOM           1
//'
//' Video capture messages
//' http://msdn.microsoft.com/en-us/library/ms713480(VS.85).aspx
#define WM_USER                        0x0400
#define WM_CAP_START                   WM_USER

#define WM_CAP_DRIVER_CONNECT          (WM_CAP_START+  10)
#define WM_CAP_DRIVER_DISCONNECT       (WM_CAP_START+  11)

#define WM_CAP_FILE_SAVEDIBA           (WM_CAP_START+  25)

#define WM_CAP_DLG_VIDEOFORMAT         (WM_CAP_START+  41)
#define WM_CAP_DLG_VIDEOSOURCE         (WM_CAP_START+  42)
#define WM_CAP_DLG_VIDEODISPLAY        (WM_CAP_START+  43)
#define WM_CAP_GET_VIDEOFORMAT         (WM_CAP_START+  44)
#define WM_CAP_SET_VIDEOFORMAT         (WM_CAP_START+  45)
#define WM_CAP_DLG_VIDEOCOMPRESSION    (WM_CAP_START+  46)

#define WM_CAP_SET_PREVIEW             (WM_CAP_START+  50)
#define WM_CAP_SET_OVERLAY             (WM_CAP_START+  51)
#define WM_CAP_SET_PREVIEWRATE         (WM_CAP_START+  52)
#define WM_CAP_SET_SCALE               (WM_CAP_START+  53)
#define WM_CAP_GET_STATUS              (WM_CAP_START+  54)
#define WM_CAP_SET_SCROLL              (WM_CAP_START+  55)

#define CRLF   CHR(13)+CHR(10)

STATIC DLLFUNCTION capGetDriverDescriptionA(nDevice,@cName,nNameLen,@cVersion,nVersionLen) ;
       USING STDCALL ;
       FROM AVICAP32.DLL

STATIC DLLFUNCTION capCreateCaptureWindowA(nDevices, dwStyle,x,y,nWidth,nHeight,hWndParent,nID) ;
       USING STDCALL ;
       FROM AVICAP32.DLL

STATIC DLLFUNCTION SendMessageA( nHWND, nMsg, nMp1, nMp2 )        ;
       USING STDCALL                                              ;
       FROM  USER32.DLL

STATIC DLLFUNCTION SetWindowPos( hWnd, hWndInsertAfter, nX, nY,   ;
                                 nWidth, nHeight, uFlags )        ;
       USING STDCALL                                              ;
       FROM  USER32.DLL

STATIC DLLFUNCTION DestroyWindow(nHwnd)                           ;
       USING STDCALL                                              ;
       FROM USER32.DLL

STATIC DLLFUNCTION BitBlt( hdcDest, nXDest, nYDest, nWidth, nHeight, hdcSrc, nXSrc, nYSrc, dwRop ) ;
       USING STDCALL                                              ;
       FROM GDI32.DLL

PROCEDURE AppSys
RETURN

PROCEDURE Main
LOCAL lExit  := .F.
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg
LOCAL aPos := {0,0}
LOCAL aSize := {684,630}

   oDlg := CapCamDlg():New(AppDesktop(),,aPos,aSize,,.F.)
   oDlg:maxButton := .F.
   oDlg:Close := { || oDlg:EndCapture() ,lExit := .T. }

   oDlg:oStart:activate := {|| oDlg:oStart:hide() ,;
                               oDlg:oGrab:Show()  ,;
                               oDlg:oStop:show()  ,;
                               oDlg:StartCapture() }

   oDlg:oGrab:activate := {||  oDlg:GrabIt() }

   oDlg:oStop:activate  := {|| oDlg:oStop:hide() ,;
                               oDlg:oGrab:hide() ,;
                               oDlg:oStart:show(),;
                               oDlg:EndCapture()  }

   // zero-based index in VB
   oDlg:Combobox1:ItemSelected := { | mp1, mp2, obj | oDlg:nSelect := ( obj:getdata() [1] ) -1 }

   oDlg:Create()
   CenterControl(oDlg)

   oDlg:AddDevice()

   oDlg:show()
   setAppFocus(oDlg:oStart)

   nEvent := xbe_None
   DO WHILE .NOT. lExit
      nEvent := AppEvent ( @mp1, @mp2, @oXbp ) // ,10 )
      DO CASE
         CASE nEvent == xbe_None

         CASE nEvent == xbeP_Quit
            QUIT   // AppQuit()
      OTHERWISE
         oXbp:HandleEvent ( nEvent, mp1, mp2 )
      ENDCASE
   ENDDO

   oDlg:destroy()

RETURN


CLASS CapCamDlg FROM CapCamForm
   EXPORTED:
      METHOD init
      METHOD create
      METHOD AddDevice()
      METHOD StartCapture()
      METHOD EndCapture()
      METHOD GrabIt()

      VAR    hHwnd
ENDCLASS

METHOD CapCamDlg:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::CapCamForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::hHwnd := 0
RETURN self

METHOD CapCamDlg:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::CapCamForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
*   ::show()

RETURN self


METHOD CapCamDlg:AddDevice()
LOCAL nDevice := 0
LOCAL cName := Space(128)
LOCAL cVersion := Space(128)
LOCAL nNameLen := Len(cName)
LOCAL nVersionlen := Len(cVersion)
LOCAL nError := 0

Do while .T.
   nError := capGetDriverDescriptionA (nDevice,@cName,nNameLen,@cVersion,nVersionLen)
   if nError <> 0
      ::Combobox1:additem(TRIM(STRTRAN(cName,CHR(0),""))+" : "+ALLTRIM(cVersion))
      nDevice++
*      cName := Space(128)
*      nNameLen := Len(cName)
*      cVersion := Space(128)
*      nVersionlen := Len(cVersion)
   ELSE
      ::Combobox1:setdata({1})
      EXIT
   ENDIF
Enddo

Return

METHOD CapCamDlg:StartCapture()
LOCAL dwStyle := bOR(WS_CHILD,WS_VISIBLE)
LOCAL nWidth  := 640
LOCAL nHeight := 480
LOCAL nError  := 0

    //
    // need ot4xb
    //
    ::hHwnd := delegated_eval( {|| capCreateCaptureWindowA("CapWindow",;
                                       dwStyle               ,;
                                       0, 0, nWidth, nHeight ,;
                                       ::oStatic:getHWND()   ,;
                                       0 ) } )

    If (::hHwnd <> 0)
        //' These calls to SendMessage return integer results but we are ignoring them.
        //' ComboBoxDevices is a DropDownList on the default form, populated by
        //' a call to EnumerateCaptureDevices
        nError := SendMessageA(::hHwnd, WM_CAP_DRIVER_CONNECT, ::nSelect, 0)
        if nError =  0
           MsgBox("can not connect to capture devices"+CRLF+;
                  "try disable capture devices and enable it again","Capture Device")
           PostAppEvent(xbeP_Activate,,, ::oStop)
           SetAppFocus(::oStart)
           RETURN
        endif

        //' Scale
        SendMessageA(::hHwnd, WM_CAP_SET_SCALE, .T., 0)
        //' Preview rate in milliseconds
        SendMessageA(::hHwnd, WM_CAP_SET_PREVIEWRATE, 25, 0)
        //' Begin preview
        SendMessageA(::hHwnd, WM_CAP_SET_PREVIEW, 1, 0)
        //' PictureBoxCapture is a PictureBox on the default form
        //' Resize the device output window to fit inside PictureBoxCapture
        SetWindowPos(::hHwnd, HWND_BOTTOM, 0, 0, nWidth, ;
                     nHeight, bOR(SWP_NOMOVE,SWP_NOZORDER) )

        // show Dialog Device
        SendMessageA(::hHwnd, WM_CAP_DLG_VIDEOFORMAT, 0, 0)

    Else
        MsgBox("No capture devices found")
    End If

RETURN

METHOD CapCamDlg:GrabIt()
LOCAL zPath  := LEFT( AppName( .t. ), LEN( AppName( .t. ) ) - LEN( AppName( .f. ) ) )
LOCAL xData
LOCAL oBMP
LOCAL aFormats
LOCAL lSuccess
LOCAL nMax  := 0
LOCAL oClipBoard

LOCAL oThread

   IF FILE(zPath+"TEST.BMP")
      FERASE(zPath+"TEST.BMP")
   ENDIF

   // http://msdn.microsoft.com/en-us/library/windows/desktop/dd743900%28v=vs.85%29.aspx
   SendMessageA(::hHwnd, WM_CAP_FILE_SAVEDIBA, 0, zPath+"TEST.BMP" )

   IF FILE(zPath+"TEST.BMP")
      Runshell( "TEST.BMP","MSPAINT.EXE")
   ELSE
      TONE(1234)
   ENDIF

RETURN

METHOD CapCamDlg:EndCapture()

    If (::hHwnd <> 0)
       //' Disconnect from the video stream
       SendMessageA(::hHwnd, WM_CAP_DRIVER_DISCONNECT, ::nSelect, 0)
       //' Destroy the output window
       DestroyWindow(::hHwnd)
   ENDIF
RETURN

CLASS CapCamForm FROM XbpDialog
   EXPORTED:
      VAR oStatic
      VAR Combobox1
      VAR oStart
      VAR oGrab
      VAR oStop
      VAR nSelect

      METHOD init
      METHOD create
ENDCLASS

METHOD CapCamForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {640,480}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )

   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpDialog:taskList := .T.
   ::XbpDialog:title := "CamCap"

   ::oStatic := XbpStatic():new( ::drawingArea, , {12,100}, {640,480}, { { XBP_PP_BGCLR, GRA_CLR_WHITE } } )
   ::oStatic:caption := ""
   ::oStatic:clipSiblings := .T.
   ::oStatic:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER

   ::Combobox1    := XbpCombobox():new( ::drawingArea, , {12,0}, {608,84}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::Combobox1:tabstop := .T.

   ::oStart  := XbpPushButton():new( ::drawingArea, , {10,12}, {100,36}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::oStart:caption := "start"
   ::oStart:tabStop := .T.
   ::oStart:activate := {|| NIL }

   ::oGrab  := XbpPushButton():new( ::drawingArea, , {320+50,12}, {100,36}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::oGrab:caption := "capture"
   ::oGrab:tabStop := .T.
   ::oGrab:visible := .F.
   ::oGrab:activate := {|| NIL }

   ::oStop   := XbpPushButton():new( ::drawingArea, , {528,12}, {100,36}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } }, .F. )
   ::oStop:caption := "Stop"
   ::oStop:tabStop := .T.
   ::oStop:visible := .F.
   ::oStop:activate := {|| NIL }

   ::nSelect := 0

RETURN self

METHOD CapCamForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::oStatic:create()

   ::Combobox1:create()

   ::oStart:create()
   ::oGrab:create()
   ::oStop:create()

RETURN self

*
*
*